unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Segment, Compress;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    ESource: TEdit;
    Compress: TCompress;
    SegCompEZ: TSegCompEZ;
    ExpandBtn: TBitBtn;
    CompressBtn: TBitBtn;
    MsgPanel: TPanel;
    Label2: TLabel;
    EDest: TEdit;
    procedure ESourceEnter(Sender: TObject);
    procedure ESourceExit(Sender: TObject);
    procedure EDestEnter(Sender: TObject);
    procedure EDestExit(Sender: TObject);
    procedure CompressBtnClick(Sender: TObject);
    procedure OnCheckFile(var filepath: String;
      mode: TCProcessMode);
    procedure ExpandBtnClick(Sender: TObject);
    procedure SegCompEZSegBeforeExpand(var SegArcList: TSegArcList);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ESourceEnter(Sender: TObject);
begin
     ESource.Clear;
     EDest.Clear;
     MsgPanel.Caption := 'Enter pathname or directory of source file';
end;

procedure TForm1.ESourceExit(Sender: TObject);
begin
     ESource.Text := ExpandFileName(ESource.Text);
end;

procedure TForm1.EDestEnter(Sender: TObject);
begin
     MsgPanel.Caption := 'Enter pathname or directory of Destination file';
end;

procedure TForm1.EDestExit(Sender: TObject);
begin
     EDest.Text := ExpandFileName(EDest.Text);
end;

procedure TForm1.CompressBtnClick(Sender: TObject);
var
   Dest:    String;
   Source:  String;
   Tmp:     String;
begin
     if ((ESource.Text = '') or (EDest.Text = '')) then
       begin
       ShowMessage('Source and Destination is required!');
       ESource.SetFocus;
       exit;
       end;

     if (FileExists(ESource.Text) = False) then
       begin
       ShowMessage('Source file does not exist!');
       ESource.SetFocus;
       exit;
       end;

     Dest := EDest.Text;
     Source := ESource.Text;
     if ( (Dest[1] = 'a') or (Dest[1] = 'b')) then
       begin
       {Use SegCompEZ to Compress file}
       SegCompEZ.SegDir := ExtractFilePath(Dest);
       Tmp := ExtractFileName(Dest);
       SegCompEZ.SegBaseName := Copy(Tmp,1,Length(Tmp)-Length(ExtractFileExt(Tmp)));
       SegCompEZ.SegSource.Add(Source);
       SegCompEZ.TargetPath := ExtractFilePath(Source);
       try
         SegCompEZ.Compress;
       except
         ShowMessage('SegCompEZ.Compress failed!');
       end; {try}
       end
     else
       begin
       {Use TCompress to Compress file}
       Compress.TargetPath := ExtractFilePath(Source);
       try
         Compress.CompressFile(Dest,Source,coLZH);
       except
         ShowMessage('Compress.CompressFile failed!');
       end; {try}
       end;
end;

procedure TForm1.ExpandBtnClick(Sender: TObject);
var
    Source:     String;
    Dest:       String;
    Tmp:        String;
    SL:         TStringList;
begin
     if ((ESource.Text = '') or (EDest.Text = '')) then
       begin
       ShowMessage('Source and Destination is required!');
       ESource.SetFocus;
       exit;
       end;

     Dest := EDest.Text;
     Source := ESource.Text;
     if ( (Source[1] = 'a') or (Source[1] = 'b')) then
       begin
       {Use SegCompEZ to Expand file}
       SegCompEZ.SegDir := ExtractFilePath(Source);
       Tmp := ExtractFileName(Source);
       SegCompEZ.SegBaseName := Copy(Tmp,1,Length(Tmp)-Length(ExtractFileExt(Tmp)));
       SegCompEZ.SegSource.Clear;
       SegCompEZ.TargetPath := '';  { look at the SegCompEZSegBeforeExpand }
                                    { for changing destination directory   }
       try
         SegCompEZ.Expand;
       except
         ShowMessage('SegCompEZ.Expand failed!');
       end; {try}
       end
     else
       begin
       Compress.MakeDirectories := True;
       Compress.TargetPath := Dest;
       SL := TStringList.Create;
       try
         Compress.ScanCompressedFile(Source,SL);
         Tmp := SL[0];
         Compress.ExpandFile(Tmp,Source);
       except
         ShowMessage('Compress.Expand failed!');
       end;
       SL.Free;
       end;
end;

procedure TForm1.OnCheckFile(var filepath: String;
  mode: TCProcessMode);
begin
     MsgPanel.Caption := 'File: ' + filepath;
     MsgPanel.Update;
end;

procedure TForm1.SegCompEZSegBeforeExpand(var SegArcList: TSegArcList);
var
   SegArc:    TSegArc;
begin
     SegArc := TSegArc(SegArcList.Items[0]);
     SegArc.Target := EDest.Text;
end;

end.
