unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Compress, Segment;

type
  TForm1 = class(TForm)
    SegCompEZ: TSegCompEZ;
    Label1: TLabel;
    ESource: TEdit;
    LB: TListBox;
    FileCnt: TLabel;
    ClearBtn: TBitBtn;
    ExpandBtn: TBitBtn;
    ScanBtn: TBitBtn;
    CompressBtn: TBitBtn;
    MsgPanel: TPanel;
    procedure FormShow(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure ESourceEnter(Sender: TObject);
    procedure ESourceExit(Sender: TObject);
    procedure CompressBtnClick(Sender: TObject);
    procedure OnFileCheckEvent(var filepath: String;
      mode: TCProcessMode);
    procedure ScanBtnClick(Sender: TObject);
    procedure ExpandBtnClick(Sender: TObject);
    procedure SegCompEZSegBeforeExpand(var SegArcList: TSegArcList);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
     ClearBtnClick(Sender);
end;

procedure TForm1.ClearBtnClick(Sender: TObject);
begin
     FileCnt.Caption := 'Files:';
     ESource.Clear;
     LB.Clear;
     MsgPanel.Caption := '';
end;

procedure TForm1.ESourceEnter(Sender: TObject);
begin
     ESource.Clear;
end;

procedure TForm1.ESourceExit(Sender: TObject);
begin
     if (ESource.Text <> '') then
       begin
       LB.Items.Add(ExpandFileName(ESource.Text));
       FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
       ESource.SetFocus;
       end;
end;

procedure TForm1.CompressBtnClick(Sender: TObject);
var
   i:    Integer;
begin
     with SegCompEZ do
       begin
       SegMultiArc := True;
       for i := 0 to LB.Items.Count-1 do
         SegSource.Add(LB.Items[i]);
       TargetPath := '';
       LB.Clear;
       FileCnt.Caption := 'Files:';
       try
         Compress;
       except
         ShowMessage('SegCompEZ.Compress failed!');
       end; {try}
       end;
     LB.Items.Add('Compress complete.');
end;

procedure TForm1.ScanBtnClick(Sender: TObject);
var
   i:     integer;
begin
     ClearBtnClick(Sender);
     with SegCompEZ do
       begin
       try
         Scan;
       except
         ShowMessage('SegCompEZ.Scan failed');
       end;

       for i := 0 to SegSource.Count-1 do
         LB.Items.Add(SegSource[i]);

       LB.Items.Add('Scan Complete.');
       end;
end;

procedure TForm1.ExpandBtnClick(Sender: TObject);
begin
     ClearBtnClick(Sender);
     with SegCompEZ do
       begin
       try
         Expand;
       except
         ShowMessage('SegCompEZ.Expand failed');
       end; {try}

       LB.Items.Add('Expand Complete.');
       end;
end;

procedure TForm1.OnFileCheckEvent(var filepath: String;
  mode: TCProcessMode);
begin
     if (mode = cmCompress) then
       begin
       LB.Items.Add(SegCompEZ.TargetPath + filepath + ' (done)');
       FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
       end
     else if (mode = cmExpand) then
       begin
       LB.Items.Add(filepath + ' (done)');
       FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
       end;
end;

procedure TForm1.SegCompEZSegBeforeExpand(var SegArcList: TSegArcList);
var
   i:       Integer;
   SegArc:  TSegArc;
   NewPath: String;
begin
     for i := 0 to SegArcList.Count-1 do
       begin
       SegArc := TSegArc(SegArcList.Items[i]);
       NewPath := SegArc.Target;
       if (InputQuery('Alternate Path','New Path',NewPath) = True) then
         begin
         if (NewPath <> '') then
           SegArc.Target := NewPath;
         end;
       end;
end;

end.
