unit Target;

interface

uses
{$IFDEF WIN32}
  Windows,
{$ELSE}
  WinTypes, WinProcs,
{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Compress, Segment;

type
  TTargetForm = class(TForm)
    GroupBox1: TGroupBox;
    ETarget: TEdit;
    LBGroup: TGroupBox;
    LB: TListBox;
    ArcHdrBtn: TBitBtn;
    ResetBtn: TBitBtn;
    CloseBtn: TBitBtn;
    procedure CloseBtnClick(Sender: TObject);
    procedure ArcHdrBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
  private
    { Private declarations }
    FSegArc:     TSegArc;
    procedure InitLB;
  public
    { Public declarations }
    function  Execute: Integer;
    property  SegArc: TSegArc read FSegArc write FSegArc;
  end;

var
  TargetForm: TTargetForm;

implementation

{$R *.DFM}

var
  SaveTarget:     String;

{===============================================================}
{===============================================================}
function TTargetForm.Execute: Integer;
var
  i:           Integer;
begin
     Result := 0;
     if (FSegArc <> nil) then
       begin
       SaveTarget := FSegArc.Target;
       ETarget.Text := FSegArc.Target;
       InitLB;
       ActiveControl := CloseBtn;
       Result := ShowModal;
       end;
end;

{===============================================================}
{===============================================================}
procedure TTargetForm.ArcHdrBtnClick(Sender: TObject);
begin
     {}
end;

{===============================================================}
{===============================================================}
procedure TTargetForm.ResetBtnClick(Sender: TObject);
begin
     FSegArc.Target := SaveTarget;
     ETarget.Text := FSegArc.Target;
     ActiveControl := CloseBtn;
end;

{===============================================================}
{===============================================================}
procedure TTargetForm.CloseBtnClick(Sender: TObject);
begin
     Close;
end;

{===============================================================}
{===============================================================}
procedure TTargetForm.InitLB;
var
   i:       Integer;
begin
     for i := 0 to SegArc.SL.Count-1 do
       LB.Items.Add(SegArc.SL[i]);

     LBGroup.Caption := 'Files: ' + IntToStr(LB.Items.Count);
     LB.ItemIndex := -1;
end;

end.
